<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>install - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="install.html">install</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="install.html#.install_as_user">install_as_user</a></li><li data-type='method' style='display: none;'><a href="install.html#.install_as_developer">install_as_developer</a></li><li data-type='method' style='display: none;'><a href="install.html#.install_a_new_package">install_a_new_package</a></li></ul></li><li><a href="make.html">make</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="make.html#.build">build</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_cpp">build_cpp</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_gyp">build_gyp</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_python">build_python</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_public">build_public</a></li><li data-type='method' style='display: none;'><a href="make.html#.test">test</a></li><li data-type='method' style='display: none;'><a href="make.html#.clean">clean</a></li><li data-type='method' style='display: none;'><a href="make.html#.sync">sync</a></li><li data-type='method' style='display: none;'><a href="make.html#.show">show</a></li><li data-type='method' style='display: none;'><a href="make.html#.usage">usage</a></li><li data-type='method' style='display: none;'><a href="make.html#.install">install</a></li></ul></li><li><a href="jsdoc2.html">jsdoc2</a></li></ul><h3>Global</h3><ul><li><a href="global.html#make-readme">make-readme</a></li><li><a href="global.html#menu">menu</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">install</h1>
    

    




<section>

<header>
    
        <h2>
        
            install
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="install"><span class="type-signature"></span>factory install<span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Explains how to install packages built with aidebuild.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id=".install_as_user"><span class="type-signature type-signature-static">(static) </span>install_as_user<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Package installation to use the package.</p>
<h2>System installation</h2>
<ul>
<li>The required system installation, using the usual LinuX installer mechanism (either <code>apt-get</code> or <code>dnf</code> depending on the distribution) writes:</li>
</ul>
<pre class="prettyprint source"><code># under fedora and equivalent
  sudo dnf install git nodejs npm wget curl libcurl-devel python3-devel
# under ubuntu, debian and equivalent (some package name adaptation may be required)
  sudo apt-get install git nodejs npm wget curl libcurl4-openssh-dev python3-dev
</code></pre>
<p>The following global npm installation are recommended to avoid heavy local installation</p>
<pre class="prettyprint source"><code>sudo npm install -g jsdoc docdash js-beautify uglify-js  bindings  express  express-fileupload node-addon-api
</code></pre>
<ul>
<li>A C++ compilation chain is also required and used for C/C++ compilation, but one is usually installed.</li>
<li>A python installation is included for some packages and the Python version <code>3.10</code>, <code>3.11</code>,  <code>3.12</code>, or <code>3.7m</code> (on RasPI)   is actually in use.</li>
<li>Complementary used tools are usual LinuX commands including <a href="https://en.wikipedia.org/wiki/Bash_(Unix_shell)">bash</a>.</li>
<li>A web browser defined in the global <code>$BROWSER</code> environment variable is also used.</li>
</ul>
<h3>Remarks:</h3>
<ul>
<li>Under <em>Ubuntu</em> you may have to install dedicated versions of <code>nodejs</code> and <code>npm</code>, please refer to the <a href="./install_on_ubuntu.sh">install_on_ubuntu.sh</a> documented script for details and easy use, after checking it is ok for you, you simply have to run the script.</li>
<li>This, presently, only works with a LinuX like distributions (including MacOS). A tutorial for a <a href="https://gitlab.inria.fr/line/aide-group/aidebuild/-/blob/master/src/install_on_windows.md">windows partial installation</a> is available here.</li>
<li>If <code>npm</code> is already installed, you may have to run <code>sudo npm install -g npm@latest</code> to install the latest version or run <code>npm cache clean --force</code>  to clear spurious files.</li>
<li>If during <code>npm install</code> the <code>npm ERR! git dep preparation failed when trying to install package.json</code> there may several different causes
<ul>
<li><code>wget</code> has been forgotten to be installed,</li>
<li>a spurious version  of npm has been installed, use, e.g., <code>sudo npm install -g npm@10.1.0</code>, to overcome;
<ul>
<li>also do not hesitate to <em>copy the whole error message</em> and <a href="mailto:aide-help@inria.fr?subject=Installation%20problem%20with%25aide%20tools">contact us</a>.</li>
</ul>
</li>
</ul>
</li>
</ul>
<h3>Complementary system installation</h3>
<ul>
<li>Depending on the package and usage the following installation are optional (without, the present mechanism will still work with reduced functionalities):
<ul>
<li>For <a href="./make.html#.build_cpp">build_cpp</a>, C/C++ debugging with <a href="https://www.sourceware.org/gdb/">gdb</a> and C/C++ dynamic profiling with <a href="https://valgrind.org/">valgrind</a> are used.</li>
<li>For <a href="./make.html#.build_gyp">build_gyp</a>, webservice construction uses <a href="https://gyp.gsrc.io/index.md">gyp</a> mechanism.</li>
<li>For <a href="./make.html#.build_python">build_python</a>, python wrapping uses the <a href="http://www.swig.org">swig</a>.</li>
<li>For <a href="./make.html#.build_public">build_public</a>, documentation generation, the <a href="https://wummel.github.io/linkchecker">linkchecker</a> tool, the LaTeX compilation chain, the <a href="https://www.libreoffice.org/">libreoffice</a> software and <a href="https://www.maplesoft.com/">maple</a> symbolic calculator, are optionally used.</li>
</ul>
</li>
</ul>
<h4>Installing opencv</h4>
<ul>
<li>When using opencv there is a need to install, depending on the distribution:</li>
</ul>
<pre class="prettyprint source"><code># under fedora and equivalent
sudo dnf     install opencv opencv-contrib opencv-devel
# under unbuntu and equivalent
sudo apt-get install libopencv-core-dev libopencv-contrib-dev
</code></pre>
<p>see <a href="https://gitlab.inria.fr/line/aide-group/tabletop/-/blob/master/src/install_rasppi.md?ref_type=heads#installing-the-opencv-library">install_rasppi</a> for more details on debian/RaspPi system</p>
<ul>
<li>
<p>When implementing aide-group software on specific hardware such as <a href="https://line.gitlabpages.inria.fr/aide-group/tabletop/">tabletop</a> on <a href="https://www.raspberrypi.org/">Raspberry-Pi</a> and <a href="https://line.gitlabpages.inria.fr/aide-group/esp32gpiocontrol/">esp32gpiocontrol</a> on <a href="https://en.wikipedia.org/wiki/ESP32">ESP32</a>, dedicated installation processes are documented within the package.</p>
</li>
<li>
<p>All other required tools are automatically installed and updated thanks to the npm mechanism, as defined in the <code>package.json</code> file, but:</p>
<ul>
<li>The command: <br/> <code>sudo npm -g install docdash js-beautify jsdoc uglify-js</code> <br/> will install required package globally, and save local space and installation time.</li>
</ul>
</li>
<li>
<p>Remark: Under some ubuntu instalation the some <code>npm warm EBADENGINE</code> and <code>errors in minimatch</code> occur withput imparing the installation.</p>
</li>
</ul>
<h2>Installing a package</h2>
<ul>
<li>
<p>This is a npm package, installed using the npm command line tools. Here npm is used because it is a very simple mechanism with a large set of tools and an active and smart community, and it is particularly adapted to multi-language (C/C++ with Javacsript, and also Python) development, and very simple web-service design, including on small hardware such as the <a href="https://www.raspberrypi.org/">Raspberry-Pi</a>, and is easy to adapt to smaller connected objects.</p>
</li>
<li>
<p>Given a package in the <code>aide-group</code> of name, say, <code>wjson</code>, simply either/or:</p>
<ul>
<li>Run in your node directory:</li>
</ul>
</li>
</ul>
<pre class="prettyprint source"><code> npm install git+https://gitlab.inria.fr/line/aide-group/wjson.git
</code></pre>
<ul>
<li>Add a line in the <code>package.json</code> file:</li>
</ul>
<pre class="prettyprint source"><code>{
 ../..
 &quot;dependencies&quot;: {
   ../..
   &quot;wjson&quot;: &quot;git+https://gitlab.inria.fr/line/aide-group/wjson.git&quot;
 }
}
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id=".install_as_developer"><span class="type-signature type-signature-static">(static) </span>install_as_developer<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Package installation to co-develop the package.</p>
<ul>
<li>
<p>This is a git source bundle of a npm package, installed using the git and npm command line tools.</p>
</li>
<li>
<p>You must start installing the required configuration as explained for <a href="#.install_as_user">here</a>.</p>
</li>
<li>
<p>To become a developer you need to:</p>
<ul>
<li>Contact the aide support (e.g., <a href="mailto:aide-help@inria.fr?subject=Joining%20%25the%20development%20aide%20team">aide-help@inria.fr</a> to open a gitlab.inria external account (please explain your motivation).</li>
<li>Accept the invitation as co-developer of <a href="https://gitlab.inria.fr/line/aide-group">https://gitlab.inria.fr/line/aide-group</a>.&quot;.</li>
<li>Create a secured computer ssh private/public key pair.
<ul>
<li>Create the key pair using, e.g, the <code>ssh-keygen -t rsa</code> command.</li>
<li>Choose the standard option to save the key in the <code>~/.ssh/id_rsa</code> file.</li>
<li>Copy the <em>public</em> key pair on your gitlab account <a href="https://gitlab.inria.fr/-/profile/keys">https://gitlab.inria.fr/-/profile/keys</a>
<em>Note:</em> Better do not reuse an existing private/public key but create a new one (you can have several ssh keys active on gitlab).</li>
</ul>
</li>
</ul>
</li>
<li>
<p>Given a package in the <code>aide-group</code> of name, say, <code>wjson</code>, simply either/or:</p>
<ul>
<li>Choose a working directory.</li>
<li>In your working directory, clone the source bundle and change to the directory to install and test:</li>
</ul>
</li>
</ul>
<pre class="prettyprint source"><code> git clone git@gitlab.inria.fr:line/aide-group/wjson.git
 cd wjson
 npm install
 npm run build
 npm test
</code></pre>
<ul>
<li>In order to recheck all elements rerun, in the package</li>
</ul>
<pre class="prettyprint source"><code> git pull ; npm run clean ; npm install ; npm run build ; npm test
</code></pre>
<ul>
<li>In order to co-develop, change to the src directory and use <a href="make.html">make</a> directives.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id=".install_a_new_package"><span class="type-signature type-signature-static">(static) </span>install_a_new_package<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Initializes a package in order to be used with aidebuild.</p>
<h2>Initialization tutorial</h2>
<ol start="0">
<li>You must be registered on the gitlab.inria.fr as <a href="#.install_as_developer">explained here</a>.</li>
<li>Create a git <a href="https://archives.docs.gitlab.com/16.3/ee/user/project/index.html">project</a> in the proper group.</li>
</ol>
<ul>
<li>Consider choosing public vibility</li>
<li>Enter a one line project desctription when creating the project or in the <code>Setting-&gt;Description</code> menu</li>
<li>Do not initialize repository with a <code>README.md</code></li>
</ul>
<ol start="2">
<li>Note the <code>Project ID</code></li>
</ol>
<ul>
<li>It is gettable from a little menu at the right of the project title</li>
<li>It is also readable on the <code>Setting =&gt; General</code> project menu page</li>
</ul>
<ol start="3">
<li>In the parent working directory, download and run <code>init.sh</code></li>
</ol>
<ul>
<li><code>wget -q https://gitlab.inria.fr/line/aide-group/aidebuild/-/raw/master/src/init.sh</code></li>
<li><code>sh ./init.sh</code>
<ul>
<li>This interactive script, asking for the <code>Project ID</code>, will generate a working directory with the proper initial files (See below).</li>
</ul>
</li>
</ul>
<ol start="4">
<li>Edit and complete the <code>./package.json</code> meta-data file.</li>
</ol>
<ul>
<li>Please consider, beyond the <a href="https://docs.npmjs.com/cli/v8/configuring-npm/package-json">general documentation</a>:
<ul>
<li><a href="https://gitlab.inria.fr/line/aide-group/aidebuild/-/blob/master/package.json">this simple example</a> and</li>
<li><a href="https://gitlab.inria.fr/line/aide-group/tabletop/-/blob/master/package.json">this more sophisticated example</a>.</li>
</ul>
</li>
<li>Please refer to the <a href="./make.html#.build_public">build_public</a> section for more information on specific meta-data options.</li>
</ul>
<ol start="5">
<li>Activate the <a href="https://gitlab.inria.fr/line/aide-group/aidebuild/-/blob/master/src/install_gitlab_page_runner.md#configure-each-projet-to-have-static-pages-active">gitlab pages</a>, to allow the package web-site to be activated, i.e.:
-On Left Menu =&gt; <code>Settings</code> =&gt; <code>General</code> =&gt; <code>Visibility, project features, permissions</code> (clic <code>Expand</code>)
<ul>
<li>Enable <code>CI/CD</code> to Build, test, and deploy your changes.</li>
<li>Enable <code>Pages</code> … to host your static websites on GitLab.</li>
<li>Clic <code>Save Changes</code>.</li>
</ul>
</li>
</ol>
<ul>
<li>On Left Menu =&gt; <code>Settings</code> =&gt; <code>CI/CD</code> =&gt; <code>Runners</code> (clic <code>Expand</code>)
<ul>
<li>Enable <code>Enable shared runners for this project</code>.</li>
<li>Clic <code>Save Changes</code>. (If no <code>Save Changes</code> button use the button of another <code>Settings</code> item).</li>
</ul>
</li>
<li>On Left Menu =&gt; <code>Deploy</code> =&gt; <code>Pages</code>
<ul>
<li>Disable <code>Use unique domain option</code> in order to obtain a https://$group.gitlabpages.inria.fr/$group/$project standard URL</li>
</ul>
</li>
</ul>
<h2>The package.json non-standard options</h2>
<p>The <a href="https://docs.npmjs.com/cli/v9/configuring-npm/package-json">package.json</a> file is expected to contain:</p>
<ul>
<li>The &quot;name&quot;, &quot;description&quot;, &quot;homepage&quot; (of the documentation), &quot;version&quot;, &quot;license&quot;, &quot;author&quot; (or &quot;contributors&quot;), &quot;repository&quot; (of the source files), &quot;scripts&quot;, &quot;dependencies&quot;, &quot;devDependecies&quot; usual fields,
But since the specification is open, it may also contain:</li>
<li>Multiple authors under the &quot;contributors&quot; field as exemplified <a href="https://gitlab.inria.fr/line/aide-group/tabletop/-/blob/master/package.json">here</a>, with &quot;name&quot;, &quot;email&quot; and &quot;url&quot; items,</li>
<li>In the &quot;repository&quot; field an additional &quot;project_ID&quot; item, corresponding to the project ID on the gitlab forge.</li>
<li>A &quot;usage&quot; field which is a list a HTML lines, to complete the installation or usage documentation <a href="https://line.gitlabpages.inria.fr/aide-group/aidebuild/jsdoc2.html">more…</a>.</li>
<li>A &quot;softwareheritage&quot; boolean field (default is false) to indicate that the software has been archived on https://archive.softwareheritage.org using <a href="https://archive.softwareheritage.org/save/list/">this link</a>.</li>
<li>A &quot;build_cpp&quot; boolean field (default is true) to indicate that <a href="https://line.gitlabpages.inria.fr/aide-group/aidebuild/make.html#.build_cpp">C/C++ compilation</a> has to be performed.</li>
<li>A &quot;swig&quot; boolean field (default is false) to indicate the that the <a href="https://line.gitlabpages.inria.fr/aide-group/aidebuild/make.html#.build_python">python wrapper</a> has to be built.</li>
<li>A &quot;gypfile&quot; boolean field (default is false) to indicate that the <a href="https://line.gitlabpages.inria.fr/aide-group/aidebuild/make.html#.build_gyp">node-gyp wrapper</a> has to be built.</li>
</ul>
<h2>Initialization hints</h2>
<ul>
<li>Your default branch <em>must</em> be <code>master</code>
<ul>
<li>to change (e.g. from <code>main</code>) to <code>master</code> consider the <code>Settings-&gt;Repository+Branch Defaults</code> menu</li>
<li>you also may have to unprotect the <code>main</code> branch in <code>Settings-&gt;Repository+Protected branches</code> menu</li>
<li>you better delete unused branches in <code>Code-&gt;Branches</code> menu</li>
</ul>
</li>
</ul>
<h2>Initialization details</h2>
<ul>
<li>
<p>This will create a directory with your project name and install the required files:</p>
<ul>
<li><code>./package.json</code> is the project package meta-data file, which is pre-formatted with all possible predefined information.</li>
<li><code>./src/makefile</code> initial file, the required aidebuild include and variable templates, to partially clear if not used.</li>
<li><code>./.gitignore</code> standard file, allowing to have clean git push and pull operations without local generated files.</li>
<li><code>./.gitlab-ci.yml</code> standard file, allowing to generate a public web-site presenting and documenting the package, with a minimal <code>./public/index.html</code> page.</li>
</ul>
</li>
<li>
<p>The present installation is specific to package on the <code>gitlab.inria.fr</code> forge but is easily adaptable to other platforms.</p>
</li>
<li>
<p>You may also read the <a href="https://gitlab.inria.fr/line/aide-group/aidebuild/-/blob/master/src/init.sh">init.sh</a> as a step by step tutorial and perform installation manually</p>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>